diff --git a/taskcluster/taskgraph/task/base.py b/taskcluster/taskgraph/task/base.py
index 2d9cbf5d95..d64d7198d3 100644
--- a/taskcluster/taskgraph/task/base.py
+++ b/taskcluster/taskgraph/task/base.py
@@ -5,9 +5,10 @@
 from __future__ import absolute_import, print_function, unicode_literals
 
 import abc
+import six
 
 
-class Task(object):
+class Task(six.with_metaclass(abc.ABCMeta, object)):
     """
     Representation of a task in a TaskGraph.  Each Task has, at creation:
 
@@ -26,7 +27,6 @@ class Task(object):
     path from which it draws its task configuration.  The instance is free to
     store as much local state as it needs.
     """
-    __metaclass__ = abc.ABCMeta
 
     def __init__(self, kind, label, attributes, task):
         self.kind = kind
diff --git a/taskcluster/taskgraph/task/docker_image.py b/taskcluster/taskgraph/task/docker_image.py
index fd67c48328..dd8a211b04 100644
--- a/taskcluster/taskgraph/task/docker_image.py
+++ b/taskcluster/taskgraph/task/docker_image.py
@@ -7,7 +7,7 @@ from __future__ import absolute_import, print_function, unicode_literals
 import logging
 import json
 import os
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 
 from . import base
 from taskgraph.util.docker import (
@@ -16,6 +16,7 @@ from taskgraph.util.docker import (
     INDEX_PREFIX,
 )
 from taskgraph.util.templates import Templates
+import six
 
 logger = logging.getLogger(__name__)
 GECKO = os.path.realpath(os.path.join(__file__, '..', '..', '..', '..'))
@@ -58,7 +59,7 @@ class DockerImageTask(base.Task):
 
         tasks = []
         templates = Templates(path)
-        for image_name, image_symbol in config['images'].iteritems():
+        for image_name, image_symbol in config['images'].items():
             context_path = os.path.join('testing', 'docker', image_name)
             context_hash = generate_context_hash(GECKO, context_path, image_name)
 
@@ -95,20 +96,20 @@ class DockerImageTask(base.Task):
         for index_path in self.index_paths:
             try:
                 url = INDEX_URL.format(index_path)
-                existing_task = json.load(urllib2.urlopen(url))
+                existing_task = json.load(six.moves.urllib.request.urlopen(url))
                 # Only return the task ID if the artifact exists for the indexed
                 # task.  Otherwise, continue on looking at each of the branches.  Method
                 # continues trying other branches in case mozilla-central has an expired
                 # artifact, but 'project' might not. Only return no task ID if all
                 # branches have been tried
-                request = urllib2.Request(
+                request = six.moves.urllib.request.Request(
                     ARTIFACT_URL.format(existing_task['taskId'], 'public/image.tar.zst'))
                 request.get_method = lambda: 'HEAD'
-                urllib2.urlopen(request)
+                six.moves.urllib.request.urlopen(request)
 
                 # HEAD success on the artifact is enough
                 return True, existing_task['taskId']
-            except urllib2.HTTPError:
+            except six.moves.urllib.error.HTTPError:
                 pass
 
         return False, None
diff --git a/taskcluster/taskgraph/task/signing.py b/taskcluster/taskgraph/task/signing.py
index a2a9ae3d66..6eff2ab751 100644
--- a/taskcluster/taskgraph/task/signing.py
+++ b/taskcluster/taskgraph/task/signing.py
@@ -33,7 +33,7 @@ class SigningTask(base.Task):
             templates = Templates(root)
             jobs = templates.load(filename, {})
 
-            for name, job in jobs.iteritems():
+            for name, job in jobs.items():
                 for artifact in job['unsigned-task']['artifacts']:
                     url = ARTIFACT_URL.format('<{}>'.format('unsigned-artifact'), artifact)
                     job['task']['payload']['unsignedArtifacts'].append({
diff --git a/taskcluster/taskgraph/task/test.py b/taskcluster/taskgraph/task/test.py
index 928f32a5a5..1309edcfbd 100644
--- a/taskcluster/taskgraph/task/test.py
+++ b/taskcluster/taskgraph/task/test.py
@@ -41,7 +41,7 @@ class TestTask(transform.TransformTask):
         test_descriptions = load_yaml(path, 'tests.yml')
 
         # generate all tests for all test platforms
-        for test_platform_name, test_platform in test_platforms.iteritems():
+        for test_platform_name, test_platform in test_platforms.items():
             for test_name in test_platform['test-names']:
                 test = copy.deepcopy(test_descriptions[test_name])
                 test['build-platform'] = test_platform['build-platform']
@@ -79,7 +79,7 @@ class TestTask(transform.TransformTask):
         based on the available build platforms.  Returns a dictionary mapping
         test platform to {test-set, build-platform, build-label}."""
         test_platforms = {}
-        for test_platform, cfg in test_platforms_cfg.iteritems():
+        for test_platform, cfg in test_platforms_cfg.items():
             build_platform = cfg['build-platform']
             if build_platform not in builds_by_platform:
                 logger.warning(
@@ -100,7 +100,7 @@ class TestTask(transform.TransformTask):
         `test-names` key for each test platform, containing a set of test
         names."""
         rv = {}
-        for test_platform, cfg in test_platforms.iteritems():
+        for test_platform, cfg in test_platforms.items():
             test_set = cfg['test-set']
             if test_set not in test_sets_cfg:
                 raise Exception(
diff --git a/taskcluster/taskgraph/task/transform.py b/taskcluster/taskgraph/task/transform.py
index 8183254a07..bc421f63be 100644
--- a/taskcluster/taskgraph/task/transform.py
+++ b/taskcluster/taskgraph/task/transform.py
@@ -48,9 +48,9 @@ class TransformTask(base.Task):
         """
         def jobs():
             defaults = config.get('job-defaults')
-            jobs = config.get('jobs', {}).iteritems()
+            jobs = config.get('jobs', {}.items())
             jobs_from = itertools.chain.from_iterable(
-                load_yaml(path, filename).iteritems()
+                load_yaml(path, filename.items())
                 for filename in config.get('jobs-from', {}))
             for name, job in itertools.chain(jobs, jobs_from):
                 if defaults:
diff --git a/taskcluster/taskgraph/taskgraph.py b/taskcluster/taskgraph/taskgraph.py
index 7736745ef5..0745588baa 100644
--- a/taskcluster/taskgraph/taskgraph.py
+++ b/taskcluster/taskgraph/taskgraph.py
@@ -52,7 +52,7 @@ class TaskGraph(object):
 
     def __iter__(self):
         "Iterate over tasks in undefined order"
-        return self.tasks.itervalues()
+        return self.tasks.values()
 
     def __repr__(self):
         return "<TaskGraph graph={!r} tasks={!r}>".format(self.graph, self.tasks)
@@ -68,7 +68,7 @@ class TaskGraph(object):
         """
         tasks = {}
         edges = set()
-        for key, value in tasks_dict.iteritems():
+        for key, value in tasks_dict.items():
             # We get the implementation from JSON
             implementation = value['kind_implementation']
             # Loading the module and creating a Task from a dictionary
@@ -76,7 +76,7 @@ class TaskGraph(object):
             tasks[key] = task_kind.from_json(value)
             if 'task_id' in value:
                 tasks[key].task_id = value['task_id']
-            for depname, dep in value['dependencies'].iteritems():
+            for depname, dep in value['dependencies'].items():
                 edges.add((key, dep, depname))
         task_graph = cls(tasks, Graph(set(tasks), edges))
         return tasks, task_graph
diff --git a/taskcluster/taskgraph/test/test_create.py b/taskcluster/taskgraph/test/test_create.py
index b8da3aec0c..56ffee86f8 100644
--- a/taskcluster/taskgraph/test/test_create.py
+++ b/taskcluster/taskgraph/test/test_create.py
@@ -46,7 +46,7 @@ class TestCreate(unittest.TestCase):
 
         create.create_tasks(taskgraph, label_to_taskid, {'level': '4'})
 
-        for tid, task in self.created_tasks.iteritems():
+        for tid, task in self.created_tasks.items():
             self.assertEqual(task['payload'], 'hello world')
             self.assertEqual(task['schedulerId'], 'gecko-level-4')
             # make sure the dependencies exist, at least
@@ -68,7 +68,7 @@ class TestCreate(unittest.TestCase):
 
         create.create_tasks(taskgraph, label_to_taskid, {'level': '4'})
 
-        for tid, task in self.created_tasks.iteritems():
+        for tid, task in self.created_tasks.items():
             self.assertEqual(task.get('dependencies'), [os.environ['TASK_ID']])
 
 
diff --git a/taskcluster/taskgraph/test/test_generator.py b/taskcluster/taskgraph/test/test_generator.py
index f1b466e4dd..4c1fea0ef1 100644
--- a/taskcluster/taskgraph/test/test_generator.py
+++ b/taskcluster/taskgraph/test/test_generator.py
@@ -102,7 +102,7 @@ class TestGenerator(unittest.TestCase):
         self.tgg = self.maketgg(['fake-t-1'])
         self.assertEqual(self.tgg.target_task_set.graph,
                          graph.Graph({'fake-t-1'}, set()))
-        self.assertEqual(self.tgg.target_task_set.tasks.keys(),
+        self.assertEqual(list(self.tgg.target_task_set.tasks.keys()),
                          ['fake-t-1'])
 
     def test_target_task_graph(self):
diff --git a/taskcluster/taskgraph/test/test_optimize.py b/taskcluster/taskgraph/test/test_optimize.py
index 8d2ddf2478..702469b9df 100644
--- a/taskcluster/taskgraph/test/test_optimize.py
+++ b/taskcluster/taskgraph/test/test_optimize.py
@@ -79,7 +79,7 @@ class TestOptimize(unittest.TestCase):
         def repl(task_id):
             return 'SLUGID' if task_id and len(task_id) == 22 else task_id
         got_annotations = {
-            t.label: (t.optimized, repl(t.task_id)) for t in graph.tasks.itervalues()
+            t.label: (t.optimized, repl(t.task_id)) for t in graph.tasks.values()
         }
         self.assertEqual(got_annotations, annotations)
 
diff --git a/taskcluster/taskgraph/test/test_transforms_base.py b/taskcluster/taskgraph/test/test_transforms_base.py
index 0a0dfcaf29..6f14eeb6a8 100644
--- a/taskcluster/taskgraph/test/test_transforms_base.py
+++ b/taskcluster/taskgraph/test/test_transforms_base.py
@@ -15,7 +15,7 @@ from voluptuous import Schema
 
 schema = Schema({
     'x': int,
-    'y': basestring,
+    'y': str,
 })
 
 transforms = TransformSequence()
@@ -55,7 +55,7 @@ class TestValidateSchema(unittest.TestCase):
         try:
             validate_schema(schema, {'x': 'not-int'}, "pfx")
             self.fail("no exception raised")
-        except Exception, e:
+        except Exception as e:
             self.failUnless(str(e).startswith("pfx\n"))
 
 
diff --git a/taskcluster/taskgraph/test/test_try_option_syntax.py b/taskcluster/taskgraph/test/test_try_option_syntax.py
index 29aa2d5a90..0ed69c1ee7 100644
--- a/taskcluster/taskgraph/test/test_try_option_syntax.py
+++ b/taskcluster/taskgraph/test/test_try_option_syntax.py
@@ -40,9 +40,9 @@ tasks = {k: v for k, v in [
     unittest_task('gtest', 'linux64'),
     talos_task('dromaeojs', 'linux64'),
 ]}
-unittest_tasks = {k: v for k, v in tasks.iteritems()
+unittest_tasks = {k: v for k, v in tasks.items()
                   if 'unittest_try_name' in v.attributes}
-talos_tasks = {k: v for k, v in tasks.iteritems()
+talos_tasks = {k: v for k, v in tasks.items()
                if 'talos_try_name' in v.attributes}
 graph_with_jobs = TaskGraph(tasks, Graph(set(tasks), set()))
 
@@ -139,7 +139,7 @@ class TestTryOptionSyntax(unittest.TestCase):
         tos = TryOptionSyntax('try: -p linux,linux64', empty_graph)
         ridealongs = list(task
                           for task in itertools.chain.from_iterable(
-                                RIDEALONG_BUILDS.itervalues()
+                                RIDEALONG_BUILDS.values()
                           )
                           if 'android' not in task)  # Don't include android-l10n
         self.assertEqual(sorted(tos.platforms), sorted(['linux', 'linux64'] + ridealongs))
diff --git a/taskcluster/taskgraph/transforms/base.py b/taskcluster/taskgraph/transforms/base.py
index aab1392521..a52ebc5025 100644
--- a/taskcluster/taskgraph/transforms/base.py
+++ b/taskcluster/taskgraph/transforms/base.py
@@ -102,7 +102,7 @@ def get_keyed_by(item, field, item_name, subfield=None):
             return value
 
     assert len(value) == 1, "Invalid attribute {} in {}".format(field, item_name)
-    keyed_by = value.keys()[0]
+    keyed_by = list(value.keys())[0]
     values = value[keyed_by]
     if keyed_by.startswith('by-'):
         keyed_by = keyed_by[3:]  # extract just the keyed-by field name
diff --git a/taskcluster/taskgraph/transforms/job/__init__.py b/taskcluster/taskgraph/transforms/job/__init__.py
index a0860c0324..52a367e65f 100644
--- a/taskcluster/taskgraph/transforms/job/__init__.py
+++ b/taskcluster/taskgraph/transforms/job/__init__.py
@@ -28,15 +28,15 @@ logger = logging.getLogger(__name__)
 
 # Voluptuous uses marker objects as dictionary *keys*, but they are not
 # comparable, so we cast all of the keys back to regular strings
-task_description_schema = {str(k): v for k, v in task_description_schema.schema.iteritems()}
+task_description_schema = {str(k): v for k, v in task_description_schema.schema.items()}
 
 # Schema for a build description
 job_description_schema = Schema({
     # The name of the job and the job's label.  At least one must be specified,
     # and the label will be generated from the name if necessary, by prepending
     # the kind.
-    Optional('name'): basestring,
-    Optional('label'): basestring,
+    Optional('name'): str,
+    Optional('label'): str,
 
     # the following fields are passed directly through to the task description,
     # possibly modified by the run implementation.  See
@@ -59,7 +59,7 @@ job_description_schema = Schema({
     # A description of how to run this job.
     'run': {
         # The key to a job implementation in a peer module to this one
-        'using': basestring,
+        'using': str,
 
         # Any remaining content is verified against that job implementation's
         # own schema.
diff --git a/taskcluster/taskgraph/transforms/job/hazard.py b/taskcluster/taskgraph/transforms/job/hazard.py
index c5b500843d..66b2ea31bc 100644
--- a/taskcluster/taskgraph/transforms/job/hazard.py
+++ b/taskcluster/taskgraph/transforms/job/hazard.py
@@ -21,20 +21,20 @@ haz_run_schema = Schema({
     Required('using'): 'hazard',
 
     # The command to run within the task image (passed through to the worker)
-    Required('command'): basestring,
+    Required('command'): str,
 
     # The tooltool manifest to use; default in the script is used if omitted
-    Optional('tooltool-manifest'): basestring,
+    Optional('tooltool-manifest'): str,
 
     # The mozconfig to use; default in the script is used if omitted
-    Optional('mozconfig'): basestring,
+    Optional('mozconfig'): str,
 
     # The set of secret names to which the task has access; these are prefixed
     # with `project/releng/gecko/{treeherder.kind}/level-{level}/`.   Setting
     # this will enable any worker features required and set the task's scopes
     # appropriately.  `true` here means ['*'], all secrets.  Not supported on
     # Windows
-    Required('secrets', default=False): Any(bool, [basestring]),
+    Required('secrets', default=False): Any(bool, [str]),
 })
 
 
diff --git a/taskcluster/taskgraph/transforms/job/mach.py b/taskcluster/taskgraph/transforms/job/mach.py
index 8df202dbcc..74f8349b3d 100644
--- a/taskcluster/taskgraph/transforms/job/mach.py
+++ b/taskcluster/taskgraph/transforms/job/mach.py
@@ -15,7 +15,7 @@ mach_schema = Schema({
     Required('using'): 'mach',
 
     # The mach command (omitting `./mach`) to run
-    Required('mach'): basestring,
+    Required('mach'): str,
 })
 
 
diff --git a/taskcluster/taskgraph/transforms/job/mozharness.py b/taskcluster/taskgraph/transforms/job/mozharness.py
index fb3cd00dd8..f85acc2135 100644
--- a/taskcluster/taskgraph/transforms/job/mozharness.py
+++ b/taskcluster/taskgraph/transforms/job/mozharness.py
@@ -28,22 +28,22 @@ mozharness_run_schema = Schema({
 
     # the mozharness script used to run this task, relative to the testing/
     # directory and using forward slashes even on Windows
-    Required('script'): basestring,
+    Required('script'): str,
 
     # the config files required for the task, relative to
     # testing/mozharness/configs and using forward slashes even on Windows
-    Required('config'): [basestring],
+    Required('config'): [str],
 
     # any additional actions to pass to the mozharness command; not supported
     # on Windows
-    Optional('actions'): [basestring],
+    Optional('actions'): [str],
 
     # any additional options (without leading --) to be passed to mozharness;
     # not supported on Windows
-    Optional('options'): [basestring],
+    Optional('options'): [str],
 
     # --custom-build-variant-cfg value (not supported on Windows)
-    Optional('custom-build-variant-cfg'): basestring,
+    Optional('custom-build-variant-cfg'): str,
 
     # If not false, tooltool downloads will be enabled via relengAPIProxy
     # for either just public files, or all files.  Not supported on Windows
@@ -58,7 +58,7 @@ mozharness_run_schema = Schema({
     # this will enable any worker features required and set the task's scopes
     # appropriately.  `true` here means ['*'], all secrets.  Not supported on
     # Windows
-    Required('secrets', default=False): Any(bool, [basestring]),
+    Required('secrets', default=False): Any(bool, [str]),
 
     # If true, taskcluster proxy will be enabled; note that it may also be enabled
     # automatically e.g., for secrets support.  Not supported on Windows.
@@ -72,7 +72,7 @@ mozharness_run_schema = Schema({
     Required('keep-artifacts', default=True): bool,
 
     # If specified, use the in-tree job script specified.
-    Optional('job-script'): basestring,
+    Optional('job-script'): str,
 })
 
 
diff --git a/taskcluster/taskgraph/transforms/job/run_task.py b/taskcluster/taskgraph/transforms/job/run_task.py
index 296fe43eee..b035873147 100644
--- a/taskcluster/taskgraph/transforms/job/run_task.py
+++ b/taskcluster/taskgraph/transforms/job/run_task.py
@@ -28,7 +28,7 @@ run_task_schema = Schema({
     # The command arguments to pass to the `run-task` script, after the
     # checkout arguments.  If a list, it will be passed directly; otherwise
     # it will be included in a single argument to `bash -cx`.
-    Required('command'): Any([basestring], basestring),
+    Required('command'): Any([str], str),
 })
 
 
@@ -49,7 +49,7 @@ def docker_worker_run_task(config, job, taskdesc):
         })
 
     run_command = run['command']
-    if isinstance(run_command, basestring):
+    if isinstance(run_command, str):
         run_command = ['bash', '-cx', run_command]
     command = ['/home/worker/bin/run-task']
     if run['checkout']:
diff --git a/taskcluster/taskgraph/transforms/job/spidermonkey.py b/taskcluster/taskgraph/transforms/job/spidermonkey.py
index d78b785046..afac6e4f0f 100644
--- a/taskcluster/taskgraph/transforms/job/spidermonkey.py
+++ b/taskcluster/taskgraph/transforms/job/spidermonkey.py
@@ -19,11 +19,11 @@ sm_run_schema = Schema({
     Required('using'): Any('spidermonkey', 'spidermonkey-package', 'spidermonkey-mozjs-crate'),
 
     # The SPIDERMONKEY_VARIANT
-    Required('spidermonkey-variant'): basestring,
+    Required('spidermonkey-variant'): str,
 
     # The tooltool manifest to use; default from sm-tooltool-config.sh  is used
     # if omitted
-    Optional('tooltool-manifest'): basestring,
+    Optional('tooltool-manifest'): str,
 })
 
 
diff --git a/taskcluster/taskgraph/transforms/job/toolchain.py b/taskcluster/taskgraph/transforms/job/toolchain.py
index d814f78249..cad067f7ee 100644
--- a/taskcluster/taskgraph/transforms/job/toolchain.py
+++ b/taskcluster/taskgraph/transforms/job/toolchain.py
@@ -19,7 +19,7 @@ toolchain_run_schema = Schema({
     Required('using'): 'toolchain-script',
 
     # the script (in taskcluster/scripts/misc) to run
-    Required('script'): basestring,
+    Required('script'): str,
 })
 
 
diff --git a/taskcluster/taskgraph/transforms/l10n.py b/taskcluster/taskgraph/transforms/l10n.py
index 42137b5581..bb07858442 100644
--- a/taskcluster/taskgraph/transforms/l10n.py
+++ b/taskcluster/taskgraph/transforms/l10n.py
@@ -21,10 +21,7 @@ def mh_config_replace_project(config, jobs):
             # Nothing to do, not mozharness
             yield job
             continue
-        job['run']['config'] = map(
-            lambda x: x.format(project=config.params['project']),
-            job['run']['config']
-            )
+        job['run']['config'] = [x.format(project=config.params['project']) for x in job['run']['config']]
         yield job
 
 
@@ -37,8 +34,5 @@ def mh_options_replace_project(config, jobs):
             # Nothing to do, not mozharness
             yield job
             continue
-        job['run']['options'] = map(
-            lambda x: x.format(project=config.params['project']),
-            job['run']['options']
-            )
+        job['run']['options'] = [x.format(project=config.params['project']) for x in job['run']['options']]
         yield job
diff --git a/taskcluster/taskgraph/transforms/task.py b/taskcluster/taskgraph/transforms/task.py
index 6e371e4baa..d4d2cc08cf 100644
--- a/taskcluster/taskgraph/transforms/task.py
+++ b/taskcluster/taskgraph/transforms/task.py
@@ -24,40 +24,40 @@ from .gecko_v2_whitelist import JOB_NAME_WHITELIST, JOB_NAME_WHITELIST_ERROR
 
 # shortcut for a string where task references are allowed
 taskref_or_string = Any(
-    basestring,
-    {Required('task-reference'): basestring})
+    str,
+    {Required('task-reference'): str})
 
 # A task description is a general description of a TaskCluster task
 task_description_schema = Schema({
     # the label for this task
-    Required('label'): basestring,
+    Required('label'): str,
 
     # description of the task (for metadata)
-    Required('description'): basestring,
+    Required('description'): str,
 
     # attributes for this task
-    Optional('attributes'): {basestring: object},
+    Optional('attributes'): {str: object},
 
     # dependencies of this task, keyed by name; these are passed through
     # verbatim and subject to the interpretation of the Task's get_dependencies
     # method.
-    Optional('dependencies'): {basestring: object},
+    Optional('dependencies'): {str: object},
 
     # expiration and deadline times, relative to task creation, with units
     # (e.g., "14 days").  Defaults are set based on the project.
-    Optional('expires-after'): basestring,
-    Optional('deadline-after'): basestring,
+    Optional('expires-after'): str,
+    Optional('deadline-after'): str,
 
     # custom routes for this task; the default treeherder routes will be added
     # automatically
-    Optional('routes'): [basestring],
+    Optional('routes'): [str],
 
     # custom scopes for this task; any scopes required for the worker will be
     # added automatically
-    Optional('scopes'): [basestring],
+    Optional('scopes'): [str],
 
     # custom "task.extra" content
-    Optional('extra'): {basestring: object},
+    Optional('extra'): {str: object},
 
     # treeherder-related information; see
     # https://schemas.taskcluster.net/taskcluster-treeherder/v1/task-treeherder-config.json
@@ -65,7 +65,7 @@ task_description_schema = Schema({
     # added to the task
     Optional('treeherder'): {
         # either a bare symbol, or "grp(sym)".
-        'symbol': basestring,
+        'symbol': str,
 
         # the job kind
         'kind': Any('build', 'test', 'other'),
@@ -76,7 +76,7 @@ task_description_schema = Schema({
         # task platform, in the form platform/collection, used to set
         # treeherder.machine.platform and treeherder.collection or
         # treeherder.labels
-        'platform': basestring,
+        'platform': str,
 
         # treeherder environments (defaults to both staging and production)
         Required('environments', default=['production', 'staging']): ['production', 'staging'],
@@ -92,15 +92,15 @@ task_description_schema = Schema({
         'job-name': Any(
             # Assuming the job is named "normally", this is the v2 job name,
             # and the v1 and buildbot routes will be determined appropriately.
-            basestring,
+            str,
 
             # otherwise, give separate names for each of the legacy index
             # routes; if a name is omitted, no corresponding route will be
             # created.
             {
                 # the name as it appears in buildbot routes
-                Optional('buildbot'): basestring,
-                Required('gecko-v2'): basestring,
+                Optional('buildbot'): str,
+                Required('gecko-v2'): str,
             }
         ),
 
@@ -128,17 +128,17 @@ task_description_schema = Schema({
     # The `run_on_projects` attribute, defaulting to "all".  This dictates the
     # projects on which this task should be included in the target task set.
     # See the attributes documentation for details.
-    Optional('run-on-projects'): [basestring],
+    Optional('run-on-projects'): [str],
 
     # If the task can be coalesced, this is the name used in the coalesce key
     # the project, etc. will be added automatically.  Note that try (level 1)
     # tasks are never coalesced
-    Optional('coalesce-name'): basestring,
+    Optional('coalesce-name'): str,
 
     # the provisioner-id/worker-type for the task.  The following parameters will
     # be substituted in this string:
     #  {level} -- the scm level of this push
-    'worker-type': basestring,
+    'worker-type': str,
 
     # information specific to the worker implementation that will run this task
     'worker': Any({
@@ -150,9 +150,9 @@ task_description_schema = Schema({
         # generally `desktop-test`, or an image that acts an awful lot like it.
         Required('docker-image'): Any(
             # a raw Docker image path (repo/image:tag)
-            basestring,
+            str,
             # an in-tree generated docker image (from `testing/docker/<name>`)
-            {'in-tree': basestring}
+            {'in-tree': str}
         ),
 
         # worker features that should be enabled
@@ -170,10 +170,10 @@ task_description_schema = Schema({
 
             # name of the cache, allowing re-use by subsequent tasks naming the
             # same cache
-            'name': basestring,
+            'name': str,
 
             # location in the task image where the cache will be mounted
-            'mount-point': basestring,
+            'mount-point': str,
         }],
 
         # artifacts to extract from the task image after completion
@@ -182,15 +182,15 @@ task_description_schema = Schema({
             'type': Any('file', 'directory'),
 
             # task image path from which to read artifact
-            'path': basestring,
+            'path': str,
 
             # name of the produced artifact (root of the names for
             # type=directory)
-            'name': basestring,
+            'name': str,
         }],
 
         # environment variables
-        Required('env', default={}): {basestring: taskref_or_string},
+        Required('env', default={}): {str: taskref_or_string},
 
         # the command to run
         'command': [taskref_or_string],
@@ -214,53 +214,53 @@ task_description_schema = Schema({
             'type': Any('file', 'directory'),
 
             # task image path from which to read artifact
-            'path': basestring,
+            'path': str,
         }],
 
         # directories and/or files to be mounted
         Optional('mounts'): [{
             # a unique name for the cache volume
-            'cache-name': basestring,
+            'cache-name': str,
 
             # task image path for the cache
-            'path': basestring,
+            'path': str,
         }],
 
         # environment variables
-        Required('env', default={}): {basestring: taskref_or_string},
+        Required('env', default={}): {str: taskref_or_string},
 
         # the maximum time to run, in seconds
         'max-run-time': int,
 
         # os user groups for test task workers
-        Optional('os-groups', default=[]): [basestring],
+        Optional('os-groups', default=[]): [str],
     }, {
         Required('implementation'): 'buildbot-bridge',
 
         # see
         # https://github.com/mozilla/buildbot-bridge/blob/master/bbb/schemas/payload.yml
-        'buildername': basestring,
+        'buildername': str,
         'sourcestamp': {
-            'branch': basestring,
-            Optional('revision'): basestring,
-            Optional('repository'): basestring,
-            Optional('project'): basestring,
+            'branch': str,
+            Optional('revision'): str,
+            Optional('repository'): str,
+            Optional('project'): str,
         },
         'properties': {
-            'product': basestring,
-            Extra: basestring,  # additional properties are allowed
+            'product': str,
+            Extra: str,  # additional properties are allowed
         },
     }, {
         'implementation': 'macosx-engine',
 
         # A link for an executable to download
-        Optional('link'): basestring,
+        Optional('link'): str,
 
         # the command to run
         Required('command'): [taskref_or_string],
 
         # environment variables
-        Optional('env'): {basestring: taskref_or_string},
+        Optional('env'): {str: taskref_or_string},
 
         # artifacts to extract from the task image after completion
         Optional('artifacts'): [{
@@ -268,11 +268,11 @@ task_description_schema = Schema({
             Required('type'): Any('file', 'directory'),
 
             # task image path from which to read artifact
-            Required('path'): basestring,
+            Required('path'): str,
 
             # name of the produced artifact (root of the names for
             # type=directory)
-            Required('name'): basestring,
+            Required('name'): str,
         }],
     }),
 
@@ -283,7 +283,7 @@ task_description_schema = Schema({
         # This task only needs to be run if a file matching one of the given
         # patterns has changed in the push.  The patterns use the mozpack
         # match function (python/mozbuild/mozpack/path.py).
-        Optional('files-changed'): [basestring],
+        Optional('files-changed'): [str],
     }),
 })
 
@@ -457,12 +457,12 @@ def build_generic_worker_payload(config, task, task_def):
 @payload_builder('macosx-engine')
 def build_macosx_engine_payload(config, task, task_def):
     worker = task['worker']
-    artifacts = map(lambda artifact: {
+    artifacts = [{
         'name': artifact['name'],
         'path': artifact['path'],
         'type': artifact['type'],
         'expires': task_def['expires'],
-    }, worker['artifacts'])
+    } for artifact in worker['artifacts']]
 
     task_def['payload'] = {
         'link': worker['link'],
@@ -494,7 +494,7 @@ def add_index_routes(config, tasks):
 
         job_name = index['job-name']
         # unpack the v2 name to v1 and buildbot names
-        if isinstance(job_name, basestring):
+        if isinstance(job_name, str):
             base_name, type_name = job_name.rsplit('-', 1)
             job_name = {
                 'buildbot': base_name,
